#include <VRS51L3074_SDCC.h>

#define NUM_CSTIMERS 5
#define NUM_SECTIMERS 5

static unsigned char c1s;
__xdata unsigned char CS_TIMERS[NUM_CSTIMERS],SEC_TIMERS[NUM_SECTIMERS];

void init_realtime(void)
{
register unsigned char r;
__xdata unsigned char *p;

  c1s=100;
  r=NUM_CSTIMERS;
  p=CS_TIMERS;
  while(r--){
    *(p++)=0;
  }
  r=NUM_SECTIMERS;
  p=SEC_TIMERS;
  while(r--){
    *(p++)=0;
  }
  PERIPHEN1 |= (1<<2);                // enable Timer 2
  TH2 = 0x9E;                         // 10ms @40MHz
  TL2 = 0x58;
  T2CLKCFG = 0x04;                    // /16 prescaler
  T2CON = 0x04;                       // START TIMER, COUNT UP
  INTSRC2 &= ~(1<<0);                   // Timer2 module interrupt
  INTEN2 |= (1<<0);                     // interrupt 8 enable
}

void tmr2Interrupt(void) interrupt 8 __naked
{
	__asm
	anl _T2CON,#~(1<<7)
        mov _TH2,#0x9E
        mov _TL2,#0x58
	push acc
        push dpl
        push dph
	push ar2
	push psw
	mov psw,#0x00
	mov dpl,#_CS_TIMERS
	mov dph,#(_CS_TIMERS >> 8)
        mov R2,#NUM_CSTIMERS
l20:	movx a,@dptr
	jz l21
	dec a
	movx @dptr,a
l21:    inc dptr
        djnz R2,l20

        dec _c1s
        mov a,_c1s
        jnz l0
        mov _c1s,#100
	mov dpl,#_SEC_TIMERS
	mov dph,#(_SEC_TIMERS >> 8)
        mov R2,#NUM_SECTIMERS
l30:	movx a,@dptr
	jz l31
	dec a
	movx @dptr,a
l31:    inc dptr
        djnz R2,l30
l0:     pop psw
        pop ar2
        pop dph
        pop dpl
        pop acc
        reti
        __endasm;
}

